/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: actor.h 12 2009-04-10 04:08:13Z segra $
 * 
 */


namespace NinjaRemixed {

	class actor : public engineObject {
	protected:
		map<size_t, animationDirection*>	 _animation;									//	Direction / Action Frames
		word								 _action;										//	Current Action
		word								 _frameNumber;									//	Current Frame
		word								 _life;											//	Current Life
		byte								*_graphicsReversed;								//	Reversed copy of the animation
		byte								 _weapon;										//	Current Weapon

		
		word								 _positionDirection;							//	Current direction
		word								 _positionX, _positionY;						//	Current X/Y

		virtual void			 actorLoadAnimation( dword *animationDirTable ) = 0;		//	Load all 4 directions from the table

	public:
								 actor( engine *Engine, word X, word Y, word Direction );
								~actor();

		bool					 cycle();
		void					 actionLoad( size_t actionNumber, size_t frames );			// Load an action, and a number of frames
		void					 directionLoad(  size_t frameSize, size_t direction, dword *actionTable, byte *bufferGraphics   );

		virtual void			 healthUpdate() = 0;
		animationFrame			*frameGet();												// Retrieve Current frame

		word					 positionXGet() { return _positionX; }						// Retrieve actor X
		word					 positionYGet() { return _positionY; }						// Retrieve actor Y
	};

}
