/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: actorEnemy.cpp 12 2009-04-10 04:08:13Z segra $
 * 
 */

#include "stdafx.h"

namespace NinjaRemixed {

	actorEnemy::actorEnemy( engine *Engine, word X, word Y, word Direction, byte weapon ) : actor( Engine, X, Y, Direction ) {
		
		actorLoadAnimation( (dword*) (_Resources->_game + 0x1092) );

		_life		 = 0x35;
		_frameNumber = 0;
		_weapon		 = weapon;

	}

	byte *actorEnemy::graphicRotate( byte *bufferGraphics ) {
		byte	 count, count2;
		word	 temp;
		
		byte	*bufferReversed = (byte*) new byte[ (51 * 177 ) * 4];
		byte	*bufferRev = bufferReversed;

		for( count = 0; count < 50; count++ ) {
			
			for( count2 = 0; count2 < 176; count2++ ) {
				
				temp = readWord(bufferGraphics) ;
				bufferGraphics+=2;

				temp = reverseWord( temp );

				*(word*)(bufferReversed + 0x160) = readWord(&temp);
				temp = readWord(bufferGraphics + 0x15E);		
				
				temp = reverseWord( temp );
				*(word*)bufferReversed = readWord(&temp);
				bufferReversed+=2;
			}

			bufferGraphics += 0x160;
			bufferReversed += 0x160;
		}

		return bufferRev;
	}

	void actorEnemy::actorLoadAnimation( dword *animationDirTable ) {			
		dword					 actionTable, bufferGraphics, bufferGraphicsPrev = 0;
		animationDirection		*animDirection = 0; 
		size_t					 direction;

		for( direction = 0; direction < 4; direction++ ) {
			
			// Read the 2 pointers
			actionTable    = (dword) (_Resources->_game + (readDWord( animationDirTable++ ) - 0x101C));
			bufferGraphics = (dword) ((readDWord( animationDirTable++ ) ));

			// If we're using the first set of graphics, read it from the game... otherwise 
			// Copy and reverse the first set
			if(bufferGraphics == 0x33DE8) {
				
				if(!_graphicsReversed)
					_graphicsReversed = graphicRotate((byte*) bufferGraphicsPrev);

				bufferGraphics = (dword)_graphicsReversed;

			} else {
				bufferGraphics += (dword) _Resources->_game;
				bufferGraphics -= 0x101C;
				bufferGraphicsPrev = bufferGraphics;	// temp
			}

			directionLoad( 0x2C0, direction, (dword*) actionTable, (byte*) bufferGraphics );
		}
	}


	void actorEnemy::healthUpdate() {
		 word	damage = 0x35 - _life;		// Starting life - Current Life

		_engine->hudGet()->enemyhealthUpdate( damage );
	}

}
