/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: actorPlayer.cpp 13 2009-04-10 05:02:33Z segra $
 * 
 */

#include "stdafx.h"

namespace NinjaRemixed {

	actorPlayer::actorPlayer( engine *Engine, word X, word Y, word Direction ) : actor( Engine, X, Y, Direction ) {
	
		actorLoadAnimation( (dword*) (_Resources->_game + 0x576) ) ;
	}

	byte *actorPlayer::graphicRotate( byte *bufferGraphics ) {
		byte	 count, count2;
		word	 temp;
		
		byte	*bufferReversed = (byte*) new byte[ (133 * 64 ) * 4];
		byte	*bufferRev = bufferReversed;

		for( count = 0; count < 63; count++ ) {
			
			for( count2 = 0; count2 < 132; count2++ ) {
				
				temp = readWord(bufferGraphics) ;
				bufferGraphics+=2;

				temp = reverseWord( temp );

				*(word*)(bufferReversed + 0x108) = readWord(&temp);
				temp = readWord(bufferGraphics + 0x106);		
				
				temp = reverseWord( temp );
				*(word*)bufferReversed = readWord(&temp);
				bufferReversed+=2;
			}

			bufferGraphics += 0x108;
			bufferReversed += 0x108;
		}

		return bufferRev;
	}

	void actorPlayer::actorLoadAnimation( dword *animationDirTable ) {			
		dword					 actionTable, bufferGraphics, bufferGraphicsPrev = 0;
		animationDirection		*animDirection = 0; 
		size_t					 direction;

		for( direction = 0; direction < 4; direction++ ) {
			
			// Read the 2 pointers
			actionTable    = (dword) (_Resources->_game + (readDWord( animationDirTable++ ) - 0x101C));
			bufferGraphics = (dword) ((readDWord( animationDirTable++ ) ));

			// If we're using the first set of graphics, read it from the game... otherwise 
			// Copy and reverse the first set
			if(bufferGraphics == 0x26908) {
				
				if(!_graphicsReversed)
					_graphicsReversed = graphicRotate((byte*) bufferGraphicsPrev);

				bufferGraphics = (dword)_graphicsReversed;

			} else {
				bufferGraphics += (dword) _Resources->_game;
				bufferGraphics -= 0x101C;
				bufferGraphicsPrev = bufferGraphics;	// temp
			}

			directionLoad( 0x210, direction, (dword*) actionTable, (byte*) bufferGraphics );
		}
	}

	void actorPlayer::healthUpdate() {

		_engine->hudGet()->playerHealthUpdate( _life );
	}


	void actorPlayer::set( levelStart *levelInfo ) {
		
		_positionX = levelInfo->playerX;
		_positionY = levelInfo->playerY - 1;

		_positionDirection = (levelInfo->playerDirection - 1);
		
	}

	void actorPlayer::roomEnter( word roomPrevious, word roomNew ) {
		word	levelCurrent = _engine->levelGet()->levelNumberGet();
		byte	level, room, roomPrev, X, Y;
		roomPrevious++;
		roomNew++;

		byte *PlayerRoomRelocate = (_Resources->_game + 0x6402) - 0x101C;
		
		while( *PlayerRoomRelocate != 0xFF ) {
			
			level	 = *PlayerRoomRelocate++;
			room	 = *PlayerRoomRelocate++;
			roomPrev = *PlayerRoomRelocate++;
			X		 = *PlayerRoomRelocate++;
			Y		 = *PlayerRoomRelocate++;

			if(level != levelCurrent)
				continue;

			if(room != roomNew)
				continue;

			if(roomPrev != roomPrevious)
				continue;

			// FIXME:
			//_positionX += X;
			//_positionY += Y;
		}

	}

}
