/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: engine.h 13 2009-04-10 05:02:33Z segra $
 * 
 */

namespace NinjaRemixed {
	
	class actor;
	class hud;
	class input;
	class level;
	class screen;
	class virtualScreen;
	class actorPlayer;

	class engine : public engineObject {
	private:
		//		Private Variables
		hud					*_hud;																// Heads up display
		input				*_input;															// User Input

		level				*_level;															// Current level
		size_t				 _levelNumber;														// Current level number
		actorPlayer			*_player;															// Player

		bool				 _quit;																// Quiting ?	
		virtualScreen		*_videoVirtual;														// Virtual Screen buffer
		screen				*_videoWindow;														// The Main Window
		
		//		Private Functions
		bool				 cycle( );															// Game cycle

	public:
		//		Public Functions

		//	Constructor/Destructor
							 engine( size_t startLevelNumber );
							~engine( );


		void				 main(  );										// Entry Point
		
		inline hud					*hudGet()			{ return _hud;			}
		inline input				*inputGet()			{ return _input;		}
		inline level				*levelGet()			{ return _level;		}
		inline actorPlayer			*playerGet()		{ return _player;		}
		inline virtualScreen		*videoVirtualGet()	{ return _videoVirtual; }

	};

}
