/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: animAction.h 12 2009-04-10 04:08:13Z segra $
 * 
 */

namespace NinjaRemixed {

	class animationAction {
	private:
		const byte						*_actionGraphics;									// Pointer to the first cell in this 'direction'
		const word						*_actionIndex;										// Pointer to the "cell number" table for this action
		map<size_t, animationFrame*>	 _frames;											// Loaded Frames for this action
		word							 _frameSize;
		word							 _width,		_height;

	public:
						 animationAction ( word maxX, word maxY, word frameSize, const byte *actionGraphics, const word *actionIndex);
						~animationAction ();

		
		animationFrame	*frameLoad ( size_t frameNumber );
		animationFrame	*frameGet  ( size_t frameNumber );
		
	};


}
