/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: animDirection.cpp 12 2009-04-10 04:08:13Z segra $
 * 
 */

#include "../stdafx.h"

namespace NinjaRemixed {

	animationDirection::animationDirection ( word width, word height, byte direction ) {
		
		_direction = direction;

		_width = width;
		_height = height;

	}

	animationDirection::~animationDirection () {

	}

		
	void	animationDirection::actionsLoad ( word frameSize, dword *actionTable, byte *bufferGraphics ) {
		dword	 actionCount;
		dword	 indexPtr;

		animationAction *animAction = 0;

		for( actionCount = 0; actionCount < 14; actionCount++ ) {
			indexPtr  = (dword) (_Resources->_game + readDWord( actionTable++ ));
			indexPtr -= 0x101C;

			animAction = new animationAction( _width, _height, frameSize, bufferGraphics, (word*) indexPtr );

			_actions.insert( pair< size_t, animationAction* >( actionCount, animAction ) );
		}


	}

	animationAction	*animationDirection::actionGet  ( size_t actionNumber ) {
		map<size_t, animationAction*>::iterator		actionIT;

		actionIT = _actions.find( actionNumber );
		
		if( actionIT == _actions.end() )
			return 0;

		return actionIT->second;
	}

	animationFrame  *animationDirection::frameGet   ( size_t actionNumber, size_t frameNumber ) {
		animationAction *Action = actionGet( actionNumber );

		return Action->frameGet( frameNumber ) ;
	}

}
