/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: animDirection.h 12 2009-04-10 04:08:13Z segra $
 * 
 */


namespace NinjaRemixed {

	class animationDirection {
	private:
		const word						*_actionTable;										// Pointer to the "cell" table for this direction
		map<size_t, animationAction*>	 _actions;											// Loaded actions for this direction
		byte							 _direction;
		word							 _width,		_height;

	public:
						 animationDirection ( word width, word height, byte direction );
						~animationDirection ();

		
		void			 actionsLoad ( word frameSize, dword *actionTable, byte *bufferGraphics );

		animationAction	*actionGet  ( size_t actionNumber );
		animationFrame  *frameGet   ( size_t actionNumber, size_t frameNumber );
		
	};


}
