/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: font.cpp 12 2009-04-10 04:08:13Z segra $
 * 
 */

#include "../stdafx.h"

namespace NinjaRemixed {

	graphicFont::graphicFont( const byte *buffer, size_t bufferSize ) : graphicSurface( 8, 8, buffer, bufferSize ) {

	}

	void graphicFont::decode(	size_t numBits, byte colorMask, const byte *buffer, size_t bufferSize ) {
		byte	*bufferCurrent = (byte*) buffer;
		byte	*bufferDest;
		byte	 bitCount, paletteIndex;
		byte	 colorIndex[3];

		// Set our buffer pointer
		_bufferSize = (bufferSize / 3) * 8;

		// Create the buffer
		_buffer = new byte[_bufferSize];
		bufferDest = (byte*) _buffer;

		clear();

		while( bufferCurrent < (byte*) (buffer + bufferSize) ) {
			colorIndex[0] = *bufferCurrent++;
			colorIndex[1] = *bufferCurrent++;
			colorIndex[2] = *bufferCurrent++;

			for( bitCount = 0; bitCount < 8; bitCount++) {
				paletteIndex = 0;
					
				if( (colorIndex[0] & 0x80))
					paletteIndex += 1;
				if( (colorIndex[1] & 0x80))
					paletteIndex += 2;
				if( (colorIndex[2] & 0x80))
					paletteIndex += 4;

				(*bufferDest++) = paletteIndex;

				// Shift bits for next pixel
				colorIndex[0] <<= 1; colorIndex[1] <<= 1; colorIndex[2] <<= 1;
			}
		}	// while bufferCurrent

		_loaded = true;
	}

	void graphicFont::load(	const byte *buffer, size_t bufferSize ) {
		decode( 3, 0x00, buffer, bufferSize );
	}

}
