/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: virtualScreen.cpp 12 2009-04-10 04:08:13Z segra $
 * 
 */

#include "..\stdafx.h"

namespace NinjaRemixed {

	virtualScreen::virtualScreen(word width, word height) : graphicImage( width, height, 0, 0  ) {

	}

	virtualScreen::~virtualScreen() {
		
	}

	void virtualScreen::fade( graphicSurface *Source, word colorLevel ) {
		
		graphicImage::blit( Source, 0, 0, 0 );
		fade( colorLevel );

	}

	void virtualScreen::fade( word colorLevel ) {
		dword *buffer = pixelGet( 0, 0 );
		byte colorRed, colorGreen, colorBlue;
		word x, y;
		word Color;

		for(y = 0; y < _maxHeight; y++) {
			for(x = 0; x < _maxWidth; x++) {
				*buffer /= 2;

				SDL_GetRGB( *buffer, _surface->format, &colorRed, &colorGreen, &colorBlue);
				Color = (colorRed << 4) + (colorGreen) + (colorBlue >> 4);
				
				Color &= 0x777;
				Color -= colorLevel;

				while(Color & 0x8)
					Color+=0x1;

				while(Color & 0x80) 
					Color+=0x10;

				while(Color & 0x800)
					Color+=0x100;

				Color &= 0x777;
				Color *= 2;
				colorRed	= (Color >> 8) & 0xF;
				colorGreen	= (Color >> 4) & 0xF;
				colorBlue	= (Color >> 0) & 0xF;

				colorRed *= 2;	colorGreen *= 2;	colorBlue *= 2;
				colorRed *= 2;	colorGreen *= 2;	colorBlue *= 2;
				colorRed *= 2;	colorGreen *= 2;	colorBlue *= 2;
				colorRed *= 2;	colorGreen *= 2;	colorBlue *= 2;

				*buffer = SDL_MapRGB( _surface->format, colorRed, colorGreen, colorBlue);

				buffer++;
			} // X
		}	// Y
	}

	void virtualScreen::pixelMask( dword mask ) {
		dword	 maskCurrent = mask;
		dword	*buffer = pixelGet( 0, 0 );
		word	 x, y;
		word	 bitOffset = 0;

		word	 difference = _maxWidth - 480;

		for(y = 0; y < 290; y++) {
			for(x = 0; x < 480; x++) {
				if((maskCurrent & 0x80))
					*buffer = 0;

				maskCurrent >>= 1;
				bitOffset++;
				if(bitOffset == 24) {
					maskCurrent = mask;
					bitOffset = 0;
				}

				buffer++;
			}
			buffer += difference;
		}

	}

}
