/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: input.cpp 12 2009-04-10 04:08:13Z segra $
 * 
 */

#include "stdafx.h"

namespace NinjaRemixed {


	input::input() : engineObject(0) {

	}

	input::~input() {

	}

	void input::decodeKeyboard( SDL_keysym keyPress ) {
		inputCommand inputLast = inputNOTHING;

		switch(keyPress.sym) {
			case SDLK_UP:
				inputLast = inputUP;
				break;
			case SDLK_DOWN:
				inputLast = inputDOWN;
				break;
			case SDLK_RIGHT:
				inputLast = inputRIGHT;
				break;
			case SDLK_LEFT:
				inputLast = inputLEFT;
				break;
			case SDLK_RCTRL:
				inputLast = inputBUTTON;
				break;
		}

		_input = inputLast;
	}

	bool input::cycle() {
		SDL_Event		 _event;
		// Check for input
		SDL_PollEvent( &_event );

		switch(_event.type) {

		case SDL_QUIT:			// Quit Event
			return false;

		case SDL_KEYUP:			// Keyboard
			decodeKeyboard( _event.key.keysym );
			break;

		}

		return true;
	}

	inputCommand	input::inputGet() {
		inputCommand tmp = _input;
		
		_input = inputNOTHING;
		return tmp;
	}


}
