/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: level.h 12 2009-04-10 04:08:13Z segra $
 * 
 */


namespace NinjaRemixed {

	class level : public engineObject {
	private:
		graphicImage	*_loadScreen;														// Loading Screen Eyes
		graphicImage	*_loadScreenName;													// Loading Screen Level Name
		size_t			 _loadTimer;														// Loading Timer

		byte			*_levelBackgrounds;													// Background Graphics Buffer
		size_t			 _levelBackgroundSize;												// Background Graphics Buffer Size

		size_t			 _levelNumber;														// This Level Number
		levelStart		*_levelStart;	
		levelData		 _levelData;														// Level Data

		size_t			 _roomNumber;														// Current Room Number
		room			*_room;																// Current Room
		vector<room*>	 _rooms;															// Loaded rooms

	public:
						 level( engine		*engine, size_t levelNumber );
						~level( );

		void			 loadData( byte		*levelPtr );									//	Read in data for _levelData
		bool			 cycle ();															//	Tick
		
		void			 roomChange( size_t  roomNumber );									//	Change to new room
		room			*roomFind  ( size_t  roomNumber );									//	Find a room
		room			*roomLoad  ( size_t  roomNumber );									//	Load a room

		inline levelData	*levelDataGet()   { return &_levelData; }							
		inline size_t		 levelNumberGet() {	return _levelNumber; }						//	Get the level number
	};

}
