/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: resources.h 12 2009-04-10 04:08:13Z segra $
 * 
 */


namespace NinjaRemixed {

	class resources {
	private:
		//		Private Variables
		string						 _dataDirectory;
		vector<graphicFont*>		 _fonts;
		vector<graphicTextScreen*>	 _text;
		
		//		Private Functions
		byte				*fileRead( string file, size_t	&fileSize );

		byte				*LOB_Decode(byte *stream, unsigned int size, unsigned int &finalSize, bool cleanup = true);
		dword				*LOB_Decode_Chunk(byte *stream, dword *streamDword, unsigned int size, unsigned int sizeTab, unsigned int &finalSize);


		void				 fontsLoad( );
		void				 stringLoad( byte *stringPtr );
		void				 stringsLoad( );		

	public:
		size_t				 _gameSize;
		byte				*_game;			// This shouldnt be here :)
		
		//		Public Functions

		//	Constructor/Destructor
							 resources( string pathFiles );
							~resources( );

		//	Prepared Data
		graphicFont			*resourceFont( byte character );										// Get character
		graphicTextScreen	*resourceText( size_t ID );												// Get Text Screen
		
		//	Raw Data
		byte				*resourceGet( unsigned int ID, size_t &fileSize );						// Load a Resource
		byte				*resourceGet( string fileName, size_t &fileSize );						// 
		byte				*resourceUnpack( byte *LOBstream, size_t &size, bool cleanup = true);	// Unpack a Resource

	};

	extern resources	*_Resources;
}
