/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: room.h 12 2009-04-10 04:08:13Z segra $
 * 
 */

namespace NinjaRemixed {
	struct levelData;

	class room : public graphicImage, public engineObject {
	private:
		actorEnemy			*_enemy;
		levelData			*_levelData;												// Level information
		word				 _levelNumber;												// Number of the level
		word				 _roomNumber;												// Number of the room
		vector<roomOverlay*> _overlays;													// Screen overlays

		item			*_roomItem;														// Item in the room

		void			 backdropLoad(byte *levelImages);								// Load the room background image
		void			 enemyLoad();													// Load the enemy (if any)
		void			 itemLoad();													// Load the rooms' item
		void			 overlaysLoad();												// Load the room overlays

	public:
						 room(engine *engine, word roomNumber, word levelNumber, byte *levelImages, levelData *leveldata);
						~room();

		bool			 cycle();

		inline levelData *levelDataGet() { return _levelData; }
		inline word		  roomNumberGet() { return _roomNumber; }
	};

}