/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: screen.cpp 12 2009-04-10 04:08:13Z segra $
 * 
 */

#include "stdafx.h"

namespace NinjaRemixed {

	screen::screen( word width, word height ) {
		initialized = false;

		// SDL Init
		SDL_Init ( SDL_INIT_VIDEO ) ;
		atexit ( SDL_Quit ) ;

		// Open the window
		surfaceWindow = SDL_SetVideoMode ( width , height , 32 , SDL_ANYFORMAT ) ;


		if(!surfaceWindow)
			return;


		initialized = true;
	}

	screen::~screen( ) {
		SDL_FreeSurface( surfaceWindow );
	}

	void screen::blit( graphicSurface *source, word x, word y ) {
		SDL_Rect destRect;

		destRect.x = x;
		destRect.y = y;
	
		SDL_BlitSurface( source->surfaceGet(), NULL, surfaceWindow, &destRect);

		SDL_UpdateRect(  surfaceWindow, 0,0,0,0);

	}

	void screen::clear( ) {
		SDL_FillRect( surfaceWindow, NULL, 0 );
	}

}
