/* The Last Ninja Remixed
 *  
 * Copyright (C) 2008-2009 Robert Crossfield
 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * 
 * $Id: stdafx.h 12 2009-04-10 04:08:13Z segra $
 * 
 */


// Windows / SDL
#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <sdl.h>

// Standard Includes
// File IO
#include <iostream>
#include <fstream>

// Containers
#include <map>
#include <sstream>
#include <vector>

using namespace std;

// Data Types
#include "types.h"

//		Endian functions
word	readWord(  const void *buffer );
dword	readDWord( const void *buffer );
word	reverseWord( word	bits);
dword	swapDWord( dword buffer );


enum inputCommand	{	inputNOTHING	= 0,
						inputUP			= 1,
						inputDOWN		= 2,
						inputLEFT		= 4,
						inputRIGHT		= 8,
						inputBUTTON		= 16 };


// Ninja Includes
#include "graphics/surface.h"
#include "graphics/image.h"
#include "graphics/imageSmall.h"
#include "graphics/animFrame.h"
#include "graphics/animAction.h"
#include "graphics/animDirection.h"
#include "graphics/font.h"
#include "graphics/textScreen.h"
#include "graphics/virtualScreen.h"
#include "engineObject.h"
#include "engine.h"
#include "input.h"
#include "healthPlayer.h"
#include "healthEnemy.h"
#include "hud.h"
#include "screen.h"
#include "actor.h"
#include "actorPlayer.h"
#include "actorEnemy.h"
#include "item.h"
#include "overlay.h"
#include "room.h"
#include "level.h"
#include "resources.h"


//		Startup

int		main( int argc, char *argv[] );
extern size_t scaleLevel;
